/**
 * @author jimmy
 */
function IQImage(){};
IQImage.init = function(canvasId,w){
    this.canvas = document.getElementById(canvasId);
    this.context = this.canvas.getContext("2d");
    this.size = w/300;
    this.min_i = -1;
    this.max_i = -1;
    $("#"+canvasId).attr("width",w);
    $("#"+canvasId).attr("height",w);
    this.context.scale(this.size,this.size);
    this.context.translate(150, 150);
}

IQImage.DrawShape = function(type,boder){
    if(boder)
        IQImage.DrawPentagon(108, boder,boder);
        
    IQImage.DrawPentagon(100, 'rgba(255,111,66,1)','rgba(255,111,66,1)');
    IQImage.DrawPentagon(80, 'rgba(255,121,85,1)','rgba(255,121,85,1)');
    IQImage.DrawPentagon(60, 'rgba(255,146,105,1)','rgba(255,146,105,1)');
    IQImage.DrawPentagon(40, 'rgba(255,154,127,1)','rgba(255,154,127,1)');
    IQImage.DrawPentagon(20, 'rgba(255,189,171,1)','rgba(255,189,171,1)'); 
    
    if(type==undefined || type ==0 )
    {
        IQImage.DrawIcon(); 
    }
    else if(type ==1)
    {
        IQImage.DrawIconText();
    }
        
}

IQImage.DrawPentagon = function(r, strokestyle,fillstyle){
        this.context.strokeStyle = strokestyle;
        this.context.fillStyle = fillstyle;
        this.context.beginPath();

        this.context.moveTo(0, -r);
        for (i = 0; i < 5; i++) {
            this.context.rotate(Math.PI * 2 / 5);
            this.context.lineTo(0, -r);
            
        }
        this.context.closePath();
        this.context.stroke();
        this.context.fill();    
}

IQImage.DrawIcon = function(){
    this.context.save();
    var size = this.size;
   // this.context.scale(1/size,1/size);
 
    var w = 30;
    var h = 30;
    var r = 100;
    IQImage.DrawImage("style/images/raid_1.png", -(w/2), -r-h-20,w,h);//逻辑：raid_0
    IQImage.DrawImage("style/images/raid_4.png", r,-25-h,w,h);//记忆：raid_4
    IQImage.DrawImage("style/images/raid_0.png", 60, 90,w,h);//想象：raid_3
    IQImage.DrawImage("style/images/raid_3.png", -60-w ,90,w,h);//计算：raid_2
    IQImage.DrawImage("style/images/raid_2.png", -r-w, -25-h,w,h);//反应：raid_1
    
    this.context.restore();
}

IQImage.DrawIconText = function(){
    this.context.save();
    this.context.font = "lighter 25px Arial"
    this.context.fillStyle = "#FFFFFF";
    this.context.lineWidth = 2;
    
    var w = 50;
    var h = 25;
    var r = 100;
    this.context.fillText("反应", -(w/2), -r-h/2);
    this.context.fillText("记忆", r, -h);    
    this.context.fillText("思维", 60, r+h/2);
    this.context.fillText("想像", -60 -w , r+h/2);
    this.context.fillText("计算", -r - w, -h );
    this.context.restore();
}

IQImage.DrawIQText = function(a,b,c,d,e,type,a1,b1,c1,d1,e1){
    this.context.save();
    this.context.font = "lighter 12px Arial"
    this.context.fillStyle = "#000";//"#9a9595";
    this.context.lineWidth = 2;
    
    
    var img_offset = 12;
    var w = 48;
    var h = 14;
    var r = 100;
    if(type==1)
    {
        this.context.fillText("反应 "+ (a1>0?("+"+a1):(a1?a1:"")), -(w/2), -r-h+img_offset);
        this.context.fillText("记忆 "+ (b1>0?("+"+b1):(b1?b1:"")), r, -20+img_offset);
        this.context.fillText("思维  "+ (c1>0?("+"+c1):(c1?c1:"")), 60, 100+3*img_offset);
        this.context.fillText("想像 "+ (d1>0?("+"+d1):(d1?d1:"")), -60 -w , 100+3*img_offset);
        this.context.fillText("计算 "+ (e1>0?("+"+e1):(e1?e1:"")), -r - w, -20 + img_offset );         
    }
    else
    {
        this.context.fillText("反应 "+a, -(w/2), -r-h+img_offset);
        this.context.fillText("记忆 "+b, r, -20+img_offset);
        this.context.fillText("思维  "+c, 60, 100+3*img_offset);
        this.context.fillText("想像 "+d, -60 -w , 100+3*img_offset);
        this.context.fillText("计算 "+e, -r - w, -20 + img_offset );        
    }


    this.context.restore();
}


IQImage.DrawImage = function(a,b,c,d,e)
{
    var imageObj = new Image();
    imageObj.src = a;
    imageObj.onload = function(){
        IQImage.drawImageObj(imageObj,b,c,d,e);
    }
}

IQImage.drawImageObj = function(imageObj, b, c, d, e){
    this.context.drawImage(imageObj, b, c, d, e);
}


IQImage.DrawUserIQ = function(x1,x2,x3,x4,x5,fill,stroke){
    //画结果填充区域
    this.context.fillStyle = 'rgba(255,255,255,0.5)';
    this.context.strokeStyle = 'rgba(255,255,255,1)';   
    if(fill)
        this.context.fillStyle = fill;
    if(stroke)
        this.context.strokeStyle = stroke;    
    this.context.lineWidth = 2;


    var l=[0,200,400,600,800,1200,1600,2400,3200];
    if(this.max_i == -1)
        this.max_i= Math.max(x1,x2,x3,x4,x5);
    if(this.min_i == -1)
        this.min_i = Math.min(x1,x2,x3,x4,x5); 

    var len = l.length;
    var begin =l[0];
    var end = l[len -1];
    for(var i=0; i<len; i++)
    {
        if(l[i]<this.min_i)
            begin =  l[i];
        if(l[len-i] >this.max_i)
            end = l[len-i]; 
    }
    function getV(i)
    {
        var v = (i - begin)*75/(end-begin) + 25;
        if(v>100)
            v=100;
        if(v<10)
            v=10;
        return v;        
    }

    
    this.context.moveTo(0, 0);
    this.context.beginPath();
    
    this.context.lineTo(0, -getV(x1));
    this.context.rotate(Math.PI * 2 / 5);
    this.context.lineTo(0, -getV(x2));
    this.context.rotate(Math.PI * 2 / 5);
    this.context.lineTo(0, -getV(x3));
    this.context.rotate(Math.PI * 2 / 5);
    this.context.lineTo(0, -getV(x4));
    this.context.rotate(Math.PI * 2 / 5);
    this.context.lineTo(0, -getV(x5));
    this.context.rotate(Math.PI * 2 / 5);
    this.context.lineTo(0, -getV(x1));   
   
    this.context.closePath();
    this.context.stroke();
    this.context.fill();    
}